Cloud CDN API, REST: ResourceRules.Create
- HTTP request
- Body parameters
- ResourceOptions
- BoolOption
- EdgeCacheSettings
- CachingTimes
- Int64Option
- StringsListOption
- QueryParamsOptions
- CompressionOptions
- RedirectOptions
- HostOptions
- StringOption
- StringsMapOption
- RewriteOption
- SecureKeyOption
- IPAddressACLOption
- FollowRedirectsOption
- WebsocketsOption
- HeaderFilterOption
- GeoACLOption
- ReferrerACLOption
- StaticResponseOption
- Response
- Status
Create new resource rule with specified unique name and rule patter.
HTTP request
POST https://cdn.api.cloud.yandex.net/cdn/v1/rules
Body parameters
{
"resourceId": "string",
"name": "string",
"rulePattern": "string",
"options": {
"disableCache": {
"enabled": "boolean",
"value": "boolean"
},
"edgeCacheSettings": {
// Includes only one of the fields `value`, `defaultValue`
"value": {
"simpleValue": "string",
"customValues": "object"
},
"defaultValue": "string",
// end of the list of possible fields
"enabled": "boolean"
},
"browserCacheSettings": {
"enabled": "boolean",
"value": "string"
},
"cacheHttpHeaders": {
"enabled": "boolean",
"value": [
"string"
]
},
"queryParamsOptions": {
// Includes only one of the fields `ignoreQueryString`, `queryParamsWhitelist`, `queryParamsBlacklist`
"ignoreQueryString": {
"enabled": "boolean",
"value": "boolean"
},
"queryParamsWhitelist": {
"enabled": "boolean",
"value": [
"string"
]
},
"queryParamsBlacklist": {
"enabled": "boolean",
"value": [
"string"
]
}
// end of the list of possible fields
},
"slice": {
"enabled": "boolean",
"value": "boolean"
},
"compressionOptions": {
// Includes only one of the fields `fetchCompressed`, `gzipOn`, `brotliCompression`
"fetchCompressed": {
"enabled": "boolean",
"value": "boolean"
},
"gzipOn": {
"enabled": "boolean",
"value": "boolean"
},
"brotliCompression": {
"enabled": "boolean",
"value": [
"string"
]
}
// end of the list of possible fields
},
"redirectOptions": {
// Includes only one of the fields `redirectHttpToHttps`, `redirectHttpsToHttp`
"redirectHttpToHttps": {
"enabled": "boolean",
"value": "boolean"
},
"redirectHttpsToHttp": {
"enabled": "boolean",
"value": "boolean"
}
// end of the list of possible fields
},
"hostOptions": {
// Includes only one of the fields `host`, `forwardHostHeader`
"host": {
"enabled": "boolean",
"value": "string"
},
"forwardHostHeader": {
"enabled": "boolean",
"value": "boolean"
}
// end of the list of possible fields
},
"staticHeaders": {
"enabled": "boolean",
"value": "object"
},
"cors": {
"enabled": "boolean",
"value": [
"string"
]
},
"stale": {
"enabled": "boolean",
"value": [
"string"
]
},
"allowedHttpMethods": {
"enabled": "boolean",
"value": [
"string"
]
},
"proxyCacheMethodsSet": {
"enabled": "boolean",
"value": "boolean"
},
"disableProxyForceRanges": {
"enabled": "boolean",
"value": "boolean"
},
"staticRequestHeaders": {
"enabled": "boolean",
"value": "object"
},
"customServerName": {
"enabled": "boolean",
"value": "string"
},
"ignoreCookie": {
"enabled": "boolean",
"value": "boolean"
},
"rewrite": {
"enabled": "boolean",
"body": "string",
"flag": "string"
},
"secureKey": {
"enabled": "boolean",
"key": "string",
"type": "string"
},
"ipAddressAcl": {
"enabled": "boolean",
"policyType": "string",
"exceptedValues": [
"string"
]
},
"followRedirects": {
"enabled": "boolean",
"codes": [
"string"
],
"useCustomHost": "boolean"
},
"websockets": {
"enabled": "boolean"
},
"headerFilter": {
"enabled": "boolean",
"headers": [
"string"
]
},
"geoAcl": {
"enabled": "boolean",
"mode": "string",
"countries": [
"string"
]
},
"referrerAcl": {
"enabled": "boolean",
"mode": "string",
"referrers": [
"string"
]
},
"staticResponse": {
"enabled": "boolean",
"code": "string",
"content": "string"
}
},
"weight": "string"
}
|
Field |
Description |
|
resourceId |
string Required field. ID of resource. The maximum string length in characters is 50. |
|
name |
string Required field. Name of created resource rule. The maximum string length in characters is 50. |
|
rulePattern |
string Required field. Resource rule pattern. The maximum string length in characters is 100. |
|
options |
|
|
weight |
string (int64) Rules are ordered by weight in ascending order (lower weights execute first) |
ResourceOptions
A major set of various resource options.
|
Field |
Description |
|
disableCache |
Set up a cache status. |
|
edgeCacheSettings |
Set up EdgeCacheSettings. |
|
browserCacheSettings |
Using Int64Option. Set up a cache period for the end-users browser. |
|
cacheHttpHeaders |
List HTTP headers that must be included in responses to clients. |
|
queryParamsOptions |
Set up QueryParamsOptions. |
|
slice |
Files larger than 10 MB will be requested and cached in parts (no larger than 10 MB each part). It reduces time to first byte. |
|
compressionOptions |
Set up compression variant. |
|
redirectOptions |
Set up redirects. |
|
hostOptions |
Set up host parameters. |
|
staticHeaders |
Set up static headers that CDN servers send in responses to clients. |
|
cors |
Parameter that lets browsers get access to selected resources from a domain |
|
stale |
List of errors which instruct CDN servers to serve stale content to clients. |
|
allowedHttpMethods |
HTTP methods for your CDN content. By default the following methods |
|
proxyCacheMethodsSet |
Allows caching for GET, HEAD and POST requests. |
|
disableProxyForceRanges |
Disabling proxy force ranges. |
|
staticRequestHeaders |
Set up custom headers that CDN servers send in requests to origins. |
|
customServerName |
Wildcard additional CNAME. |
|
ignoreCookie |
Using BoolOption for ignoring cookie. |
|
rewrite |
Changing or redirecting query paths. |
|
secureKey |
Secure token to protect contect and limit access by IP addresses and time limits. |
|
ipAddressAcl |
Manage the state of the IP access policy option. |
|
followRedirects |
Manage the state of the Redirection from origin option. |
|
websockets |
Configuration for WebSocket protocol support. |
|
headerFilter |
Configuration for HTTP response header filtering. |
|
geoAcl |
Configuration for geographic access control. |
|
referrerAcl |
Configuration for referrer-based access control. |
|
staticResponse |
Configuration for serving a static HTTP response instead of fetching from origin. |
BoolOption
Set up bool values.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
value |
boolean Value of the option. |
EdgeCacheSettings
A set of the edge cache parameters.
|
Field |
Description |
|
value |
Value of the option. Includes only one of the fields |
|
defaultValue |
string (int64) Content will be cached according to origin cache settings. Includes only one of the fields |
|
enabled |
boolean True - the option is enabled and its |
CachingTimes
A set of the caching response time parameters.
|
Field |
Description |
|
simpleValue |
string (int64) Caching time for a response with codes 200, 206, 301, 302. |
|
customValues |
object (map<string, string (int64)>) Caching time for a response with specific codes. These settings have a higher priority than the value field. |
Int64Option
A set of the numeric parameters.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
value |
string (int64) Value of the option. |
StringsListOption
A set of the string list parameters.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
value[] |
string Value of the option. |
QueryParamsOptions
A set of the query parameters.
|
Field |
Description |
|
ignoreQueryString |
Using BoolOption. Selected by default. Files with different query parameters are cached as objects with the same key regardless of the parameter value. Includes only one of the fields |
|
queryParamsWhitelist |
Ignore All Except. Includes only one of the fields |
|
queryParamsBlacklist |
Ignore only. Files with the specified query parameters are cached as objects with the same key, Includes only one of the fields |
CompressionOptions
A set of the compression variant parameters.
|
Field |
Description |
|
fetchCompressed |
The Fetch compressed option helps you to reduce Includes only one of the fields |
|
gzipOn |
Using BoolOption. GZip compression at CDN servers reduces file size by 70% and can be as high as 90%. Includes only one of the fields |
|
brotliCompression |
The option allows to compress content with brotli on the CDN's end. Includes only one of the fields |
RedirectOptions
A set of the redirect parameters.
|
Field |
Description |
|
redirectHttpToHttps |
Using BoolOption. Set up a redirect from HTTPS to HTTP. Includes only one of the fields |
|
redirectHttpsToHttp |
Using BoolOption. Set up a redirect from HTTP to HTTPS. Includes only one of the fields |
HostOptions
A set of the host parameters.
|
Field |
Description |
|
host |
Custom value for the Host header. Includes only one of the fields |
|
forwardHostHeader |
Using BoolOption. Choose the Forward Host header option if is important to send in the request to the Origin Includes only one of the fields |
StringOption
A set of the string parameters.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
value |
string Value of the option. |
StringsMapOption
A set of the strings map parameters.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
value |
object (map<string, string>) Value of the option. |
RewriteOption
An option for changing or redirecting query paths.
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its |
|
body |
string Pattern for rewrite. |
|
flag |
enum (RewriteFlag) Break flag is applied to the option by default.
|
SecureKeyOption
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its flag is applied to the resource. |
|
key |
string The key for the URL signing. |
|
type |
enum (SecureKeyURLType) The type of the URL signing. The URL could be available for all IP addresses or for the only one IP.
|
IPAddressACLOption
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its flag is applied to the resource. |
|
policyType |
enum (PolicyType) The policy type. One of allow or deny value.
|
|
exceptedValues[] |
string The list of IP addresses to be allowed or denied. |
FollowRedirectsOption
|
Field |
Description |
|
enabled |
boolean True - the option is enabled and its flag is applied to the resource. |
|
codes[] |
string (int64) Add the redirect HTTP status codes that the source returns. |
|
useCustomHost |
boolean Use the redirect target domain as a Host header, or leave it the same as the value of the Change Host header option. |
WebsocketsOption
|
Field |
Description |
|
enabled |
boolean Enables or disables feature. |
HeaderFilterOption
|
Field |
Description |
|
enabled |
boolean Enables or disables feature. |
|
headers[] |
string Whitelist of headers. |
GeoACLOption
|
Field |
Description |
|
enabled |
boolean Enables or disables the Geo ACL option. |
|
mode |
enum (Mode) Mode of the Geo ACL.
|
|
countries[] |
string List of country codes (ISO 3166, uppercase). |
ReferrerACLOption
|
Field |
Description |
|
enabled |
boolean Enables or disables feature. |
|
mode |
enum (Mode) Access mode for the referrer list.
|
|
referrers[] |
string List of referer patterns. Supports three types of values:
|
StaticResponseOption
|
Field |
Description |
|
enabled |
boolean Enables or disables feature. |
|
code |
string (int64) HTTP status code. |
|
content |
string A string containing the response content. |
Response
HTTP Code: 200 - OK
{
"id": "string",
"description": "string",
"createdAt": "string",
"createdBy": "string",
"modifiedAt": "string",
"done": "boolean",
"metadata": "object",
// Includes only one of the fields `error`, `response`
"error": {
"code": "integer",
"message": "string",
"details": [
"object"
]
},
"response": "object"
// end of the list of possible fields
}
An Operation resource. For more information, see Operation.
|
Field |
Description |
|
id |
string ID of the operation. |
|
description |
string Description of the operation. 0-256 characters long. |
|
createdAt |
string (date-time) Creation timestamp. String in RFC3339 To work with values in this field, use the APIs described in the |
|
createdBy |
string ID of the user or service account who initiated the operation. |
|
modifiedAt |
string (date-time) The time when the Operation resource was last modified. String in RFC3339 To work with values in this field, use the APIs described in the |
|
done |
boolean If the value is |
|
metadata |
object Service-specific metadata associated with the operation. |
|
error |
The error result of the operation in case of failure or cancellation. Includes only one of the fields The operation result. |
|
response |
object The normal response of the operation in case of success. Includes only one of the fields The operation result. |
Status
The error result of the operation in case of failure or cancellation.
|
Field |
Description |
|
code |
integer (int32) Error code. An enum value of google.rpc.Code |
|
message |
string An error message. |
|
details[] |
object A list of messages that carry the error details. |